{% extends 'base.html.twig' %}

{% block title %}Home Page{% endblock %}

{% block body %}

<div style="background-color: #f8f9fc; min-height: 100%">

    {% set groupAmount = 0 %}
    {% set needToPayAmount = 0 %}
    {% set paidAmount = 0 %}
    {% set wantedUser = app.user %}
    {% set wantedPaymentAmount = null %}
    {% for g in app.user.getGroups() %}
        {% set groupAmount = groupAmount + 1 %}
    {% endfor %}

    {% for p in app.user.getPayments() %}
        {% if p.isPaid == false %}
            {% if app.user == p.userWhoNeedToPay %}
                {% set needToPayAmount = needToPayAmount + p.amount %}
            {% elseif app.user == p.userWhoPaid %}
                {% set paidAmount = paidAmount + p.amount %}
                {% if p.amount > wantedPaymentAmount %}
                    {% set wantedUser = p.userWhoNeedToPay %}
                {% endif %}
            {% endif %}
        {% endif %}
    {% endfor %}

    <div class="container-fluid px-5">
        <div class="row">

            <div class="col-5 mb-5 mt-5">
                <h1 class="font-weight-bold d-inline">Salutation {{ app.user.firstname }}!</h1>
            </div>
            <div class="col-7 mb-5 mt-5 text-right">
                <a href="{{ path("addGroup") }}"><button type="button" class="btn btn-success d-inline mr-2">Créer un groupe</button></a>
                <a href="{{ path('app_logout') }}"><button type="button" class="btn btn-danger d-inline mr-4">Déconnexion</button></a>
            </div>

                <div class="col-xl-3 col-md-6 mb-4">
                    <div class="card border-left-primary shadow h-100 py-2">
                        <div class="card-body">
                            <div class="row no-gutters align-items-center">
                                <div class="col mr-2">
                                    <div class="text-xs font-weight-bold text-danger text-uppercase mb-1">Ce que vous devez</div>
                                    <div class="h5 mb-0 font-weight-bold text-gray-800">{{ needToPayAmount }}€</div>
                                </div>
                                <div class="col-auto">
                                    <i class="fas fa-hand-holding-usd fa-2x text-gray-300"></i>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>

                <div class="col-xl-3 col-md-6 mb-4">
                    <div class="card border-left-success shadow h-100 py-2">
                        <div class="card-body">
                            <div class="row no-gutters align-items-center">
                                <div class="col mr-2">
                                    <div class="text-xs font-weight-bold text-success text-uppercase mb-1">Ce qu'on vous doit</div>
                                    <div class="h5 mb-0 font-weight-bold text-gray-800">{{ paidAmount }}€</div>
                                </div>
                                <div class="col-auto">
                                    <i class="fas fa-dollar-sign fa-2x text-gray-300"></i>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>

                <div class="col-xl-3 col-md-6 mb-4">
                    <div class="card border-left-info shadow h-100 py-2">
                        <div class="card-body">
                            <div class="row no-gutters align-items-center">
                                <div class="col mr-2">
                                    <div class="text-xs font-weight-bold text-success text-uppercase mb-1">Vous doit le plus d'argent</div>
                                    <div class="h5 mb-0 font-weight-bold text-gray-800">{% if wantedUser == app.user %}Personne pour le moment{% else %}{{ wantedUser.firstName }} {{ wantedUser.lastName }}{% endif %}</div>
                                </div>
                                <div class="col-auto">
                                    <i class="fas fa-bullseye fa-2x text-gray-300"></i>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>

                <div class="col-xl-3 col-md-6 mb-4">
                    <div class="card border-left-warning shadow h-100 py-2">
                        <div class="card-body">
                            <div class="row no-gutters align-items-center">
                                <div class="col mr-2">
                                    <div class="text-xs font-weight-bold text-success text-uppercase mb-1">Groupes</div>
                                    <div class="h5 mb-0 font-weight-bold text-gray-800">{{ groupAmount }}</div>
                                </div>
                                <div class="col-auto">
                                    <i class="fas fa-users fa-2x text-gray-300"></i>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <div class="row">

                <div class="col-lg-5 mb-4">

                    <div class="card shadow mb-4">
                        <div class="card-header py-3">
                            <h6 class="m-0 font-weight-bold text-success">Fil d'actualité de vos Paiements</h6>
                        </div>
                        <div class="card-body p-0">
                            {% if app.user.getPayments() is empty %}
                                <p class="ml-3 my-3">Il n'y a pas de paiements pour le moment</p>
                            {% endif %}
                            {% for p in app.user.getPayments() %}
                                {% if p.isPaid == false %}
                                    <div class="row no-gutters align-items-center border-bottom px-4 py-3">
                                        <div class="col mr-2">
                                            <div class="text-xs font-weight-bold text-uppercase mb-1">{{ p.title }}</div>
                                            {% if app.user == p.userWhoNeedToPay %}
                                                <div class="h5 mb-0 font-weight-light text-gray-800">Vous {% if p.isPaid == false %}devez{% else %}deviez{% endif %} {{ p.amount }}€ à {{ p.userWhoPaid.firstName }} {{ p.userWhoPaid.lastName }}</div>
                                            {% elseif app.user == p.userWhoPaid %}
                                                <div class="h5 mb-0 font-weight-light text-gray-800">{{ p.userWhoNeedToPay.firstName }} {{ p.userWhoNeedToPay.lastName }} vous {% if p.isPaid == false %}doit{% else %}devait{% endif %} {{ p.amount }}€</div>
                                            {% endif %}
                                        </div>
                                        <div class="col-auto">
                                            <button type="button" data-toggle="modal" data-target="#{{ p.id }}" class="btn {% if app.user == p.userWhoNeedToPay %}btn-outline-danger{% elseif app.user == p.userWhoPaid %}btn-outline-success{% endif %}">Voir les détails</button>
                                        </div>
                                    </div>
                                {% endif %}
                            {% endfor %}
                        </div>
                    </div>

                </div>

                <div class="col-lg-3 mb-4">
                    <div class="card shadow mb-4">
                        <div class="card-header py-3">
                            <h6 class="m-0 font-weight-bold text-success">Le graphique</h6>
                        </div>
                        <div class="card-body p-4">
                            <div class="mb-3 text-center small">
                                <span class="mr-2"><i class="fas fa-circle text-danger"></i> Vous devez à quelqu'un</span>
                                <span class="mr-2"><i class="fas fa-circle text-success"></i> Quelqu'un vous doit</span>
                            </div>
                            <canvas id="e" width="250" height="400"></canvas>
                        </div>
                    </div>
                </div>

                <div class="col-lg-4 mb-4">

                    <div class="card shadow mb-4">
                        <div class="card-header py-3">
                            <h6 class="m-0 font-weight-bold text-success">Vos Groupes</h6>
                        </div>
                        <div class="card-body p-0">
                                {% if app.user.getGroups() is empty %}
                                    <p class="ml-3 my-3">Vous n'avez pas de groupe pour le moment</p>
                                {% endif %}
                            {% for g in app.user.getGroups() %}
                                {% set total = 0 %}
                                {% for p in g.payments %}
                                    {% set total = total + p.amount %}
                                {% endfor %}
                                <div class="row no-gutters align-items-center border-bottom px-4 py-3">
                                    <div class="col mr-2">
                                        <div class="text-xs font-weight-bold text-uppercase mb-1">{{ g.title }}</div>
                                    </div>
                                    <div class="col-auto">
                                        <a href="{{ path("detailGroup", {"id": g.id}) }}"><button type="button" class="btn btn-outline-success">Voir les détails</button></a>
                                    </div>
                                </div>
                            {% endfor %}
                        </div>
                    </div>
                </div>

            </div>

        </div>
    </div>

    {% for p in app.user.getPayments() %}
        <div class="modal fade" id="{{ p.id }}" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
            <div class="modal-dialog modal-dialog-centered" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="exampleModalLongTitle">{{ p.title }}</h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        <div class="row">
                            <div class="col-12">
                                <span><strong>A payé:</strong> {{ p.userWhoPaid.firstName }} {{ p.userWhoPaid.lastName }}</span>
                            </div>
                            <div class="col-12">
                                <span><strong>Doit rembourser:</strong> {{ p.userWhoNeedToPay.firstName }} {{ p.userWhoNeedToPay.lastName }}</span>
                            </div>
                            <div class="col-12">
                                <span><strong>Montant:</strong> {{ p.amount }}€</span>
                            </div>
                            <div class="col-12">
                                <span><strong>Date: </strong>{{ p.date|date('d/m/Y') }}</span>
                            </div>
                            <div class="col-12">
                                <span><strong>Remboursé: </strong>{% if p.isPaid == true %}oui{% else %}nope{% endif %}</span>
                            </div>
                            <div class="col-12">
                                <span><strong>Groupe: </strong>{{ p.groupId.title }}</span>
                            </div>
                        </div>
                    </div>
                    <div class="modal-footer">
                        {% if p.isPaid == false %}
                        <a href="{{ path("refundPayment", {"paymentId": p.id, "previousPage": "add", "groupId": p.groupId.id}) }}">
                            <button type="button" class="btn btn-success">{% if p.userWhoNeedToPay == app.user %}J'ai remboursé ce paiement{% elseif p.userWhoPaid == app.user %}Ce paiement a été remboursé{% endif %}</button></a>
                        {% endif %}
                        <button type="button" class="btn btn-secondary" data-dismiss="modal">Fermer</button>
                    </div>
                    </div>
                </div>
            </div>
        </div>
    {% endfor %}

    {% set paiementsUsers = [] %}
    {% set paiementsValue = [] %}
    {% set paiementsColor = [] %}
    {% set previousUser = null %}
    {% for p in app.user.getPayments() %}
        {% if p.isPaid == false %}
            {% if app.user == p.userWhoPaid %}
                {% set paiementsUsers = paiementsUsers|merge([p.userWhoNeedToPay]) %}
                {% set paiementsColor = paiementsColor|merge(['#28a745']) %}
                {% set paiementsValue = paiementsValue|merge([p.amount]) %}
            {% elseif app.user == p.userWhoNeedToPay %}
                {% set paiementsUsers = paiementsUsers|merge([p.userWhoPaid]) %}
                {% set paiementsColor = paiementsColor|merge(['#dc3545']) %}
                {% set paiementsValue = paiementsValue|merge([-p.amount]) %}
            {% endif %}
        {% endif %}
    {% endfor %}

    <script>
        var ctx = document.getElementById('e').getContext('2d');
        var myChart = new Chart(ctx, {
            type: 'horizontalBar',
            data: {
                labels: [{% for pUser in paiementsUsers %}'{{ pUser.firstName }} {{ pUser.lastName }}',{% endfor %}],
                datasets: [
                    {backgroundColor: [{%  for pColor in paiementsColor %}'{{ pColor }}',{% endfor %}], data: [{%  for pValue in paiementsValue %}'{{ pValue }}',{% endfor %}]},
                ]
            },
            options: {
                scales: {
                    xAxes: [{display: true, gridLines: {drawBorder: false}}],
                    yAxes: [{gridLines: {drawBorder: false}, ticks: {display: false}}]
                },
                elements: {
                    rectangle: {
                        borderWidth: 0,
                    }
                },
                responsive: true,
                legend: {
                    display: false,
                },
            }
        });
    </script>
{% endblock %}
